light cs655directionalLight(
    float intensity = 1;
    color lightcolor = 1;
    point from = point "shader" (0, 0, 0);
    point to   = point "shader" (0, 0, 1);
    float jitter = 0 )
{
	vector direction = to - from;
	
    if ( jitter != 0 )
    {
    	/* Construct orthogonal components to direction */
		vector uoffset = jitter * normalize ( vector ( 
			zcomp( direction ) - ycomp( direction ),
			xcomp( direction ) - zcomp( direction ),
			ycomp( direction ) - xcomp( direction ) ) );
			
		vector voffset = direction ^ uoffset;
		
		/* Add a random offset to the smooth direction vector */
		direction += ( float random() - 0.5 ) * uoffset + ( float random() - 0.5 ) * voffset;
    }
    
    solar(direction, 0.0)
        Cl = intensity * lightcolor;
}
