/*---------------------------------------------------------------------
 *
 * Copyright (c) 1988 Pixar.   All rights reserved.   This data file and
 * the model it represents contains  proprietary confidential information
 * and trade secrets of Pixar.  Reverse engineering of binary code
 * is prohibited.   Use of copyright  notice is precautionary  and
 * does not imply publication.
 *
 *                    RESTRICTED RIGHTS NOTICE
 *
 * Use,  duplication,  or disclosure by the Government is subject to
 * restrictions as set forth in subdivision (b)(3)(ii) of the Rights
 * in Technical Data and Computer Software clause at 252.227-7013.
 *
 * Pixar
 * 3240 Kerner Blvd.
 * San Rafael, CA  94901
 *
 *--------------------------------------------------------------------*/

surface
sferrule(float Ka=1, Ks=1, roughness=.25;
		color grn=color(0,.125,0), yel=color(1,.46,0))
{
	point Nf, V;
	color cout;

	Nf = faceforward(normalize(N), I);
	V = normalize(-I);

	if ((v >= .22) && (v <= .24))
	    cout = mix(grn, yel, (v-.22)/.02);
	else if ((v > .24) && (v < .31))
	    cout = yel;
	else if ((v >= .31) && (v <= .33))
	    cout = mix(yel, grn, (v-.31)/.02);
	else if ((v >= .68) && (v <= .70))
	    cout = mix(grn, yel, (v-.68)/.02);
	else if ((v > .70) && (v < .77))
	    cout = yel;
	else if ((v >= .77) && (v <= .79))
	    cout = mix(yel, grn, (v-.77)/.02);
	else
	    cout = grn;

	Oi = Os;
	Ci = Os * cout * (Ka*ambient() + Ks*specular(Nf,V,roughness));
}
